#ifndef _EXTENSIONS_C_
#define _EXTENSIONS_C_

#include "SDL.h"
#include "SDL_opengl.h"
#include "GL/glext.h"

#include "common.h"
#include "extensions.h"

int UseMultitexture;

// ARB_multitexture
//PFNGLMULTITEXCOORD2FARBPROC pglMultiTexCoord2fARB = NULL;

// Texture Compression
PFNGLCOMPRESSEDTEXIMAGE2DARBPROC pglCompressedTexImage2DARB = NULL;

// VBOs
/*
PFNGLGENBUFFERSARBPROC pglGenBuffersARB = NULL;
PFNGLBINDBUFFERARBPROC pglBindBufferARB = NULL;
PFNGLBUFFERDATAARBPROC pglBufferDataARB = NULL;
PFNGLBUFFERSUBDATAARBPROC pglBufferSubDataARB = NULL;
PFNGLDELETEBUFFERSARBPROC pglDeleteBuffersARB = NULL;
*/

// Shaders
/*
PFNGLCREATEPROGRAMOBJECTARBPROC pglCreateProgram = NULL;
PFNGLCREATESHADEROBJECTARBPROC pglCreateShader = NULL;
PFNGLCOMPILESHADERARBPROC pglCompileShader = NULL;
PFNGLSHADERSOURCEARBPROC pglShaderSource = NULL;
PFNGLGETSHADERINFOLOGPROC pglGetShaderInfoLog = NULL;
PFNGLGETSHADERSOURCEARBPROC pglGetShaderSource = NULL;
PFNGLGETSHADERIVPROC pglGetShaderiv = NULL;
PFNGLDELETESHADERPROC pglDeleteShader = NULL;
PFNGLDELETEPROGRAMPROC pglDeleteProgram = NULL;

PFNGLGETPROGRAMINFOLOGPROC pglGetProgramInfoLog = NULL;
PFNGLVALIDATEPROGRAMARBPROC pglValidateProgram = NULL;
PFNGLGETPROGRAMIVPROC pglGetProgramiv = NULL;
PFNGLATTACHSHADERPROC pglAttachShader = NULL;
PFNGLDETACHSHADERPROC pglDetachShader = NULL;
PFNGLLINKPROGRAMPROC pglLinkProgram = NULL;
PFNGLUSEPROGRAMPROC pglUseProgram = NULL;
PFNGLBINDATTRIBLOCATIONPROC pglBindAttribLocation = NULL;
PFNGLGETATTRIBLOCATIONPROC pglGetAttribLocation = NULL;
PFNGLGETACTIVEATTRIBPROC pglGetActiveAttrib = NULL;
PFNGLGETACTIVEUNIFORMPROC pglGetActiveUniform = NULL;
PFNGLGETATTACHEDSHADERSPROC pglGetAttachedShaders = NULL;
PFNGLGETUNIFORMLOCATIONPROC pglGetUniformLocation = NULL;
PFNGLUNIFORM1FPROC pglUniform1f = NULL;
PFNGLUNIFORM2FPROC pglUniform2f = NULL;
PFNGLUNIFORM3FPROC pglUniform3f = NULL;
PFNGLUNIFORM4FPROC pglUniform4f = NULL;
PFNGLUNIFORM1IPROC pglUniform1i = NULL;
PFNGLUNIFORM2IPROC pglUniform2i = NULL;
PFNGLUNIFORM3IPROC pglUniform3i = NULL;
PFNGLUNIFORM4IPROC pglUniform4i = NULL;
PFNGLUNIFORMMATRIX2FVPROC pglUniformMatrix2fv = NULL;
PFNGLUNIFORMMATRIX3FVPROC pglUniformMatrix3fv = NULL;
PFNGLUNIFORMMATRIX4FVPROC pglUniformMatrix4fv = NULL;
*/

// Texture compression functions
void glCompressedTexImage2DARB (GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data)
{
	pglCompressedTexImage2DARB (target, level, internalformat, width, height, border, imageSize, data);
}

// VBO functions
/*
void glGenBuffersARB (GLsizei n, GLuint *buffers)
{
	pglGenBuffersARB (n, buffers);
}

void glBindBufferARB (GLenum a, GLint b)
{
	pglBindBufferARB (a, b);
}

void glBufferDataARB (GLenum target, GLsizeiptrARB size, const GLvoid *data, GLenum usage)
{
	pglBufferDataARB (target, size, data, usage);
}

void glBufferSubDataARB (GLenum target, GLintptrARB offset, GLsizeiptrARB size, const GLvoid *data)
{
	pglBufferSubDataARB (target, offset, size, data);
}

void glDeleteBuffersARB (GLsizei n, const GLuint *buffers)
{
	pglDeleteBuffersARB (n, buffers);
}
*/

// Shader functions

/*
GLhandleARB glCreateProgram()
{
	return pglCreateProgram();
}

GLhandleARB glCreateShader (GLenum shaderType)
{
	return pglCreateShader(shaderType);
}

void glShaderSource (GLhandleARB shaderObj, GLsizei count, const GLcharARB* *string, const GLint *length)
{
	pglShaderSource(shaderObj, count, string, length);
}

void glCompileShader (GLhandleARB shaderObj)
{
	pglCompileShader (shaderObj);
}

void glGetShaderInfoLog (GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
{
	pglGetShaderInfoLog (shader, bufSize, length, infoLog);
}

void glGetShaderSource (GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *source)
{
	pglGetShaderSource (obj, maxLength, length, source);
}

void glGetShaderiv (GLuint shader, GLenum pname, GLint *params)
{
	pglGetShaderiv (shader, pname, params);
}

void glDeleteShader (GLuint shader)
{
	pglDeleteShader (shader);
}

void glDeleteProgram (GLuint program)
{
	pglDeleteProgram (program);
}

void glGetProgramInfoLog (GLuint program, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
{
	pglGetProgramInfoLog (program, bufSize, length, infoLog);
}

void glValidateProgram (GLhandleARB programObj)
{
	pglValidateProgram (programObj);
}

void glGetProgramiv (GLuint program, GLenum pname, GLint *params)
{
	pglGetProgramiv (program, pname, params);
}

void glAttachShader (GLuint program, GLuint shader)
{
	pglAttachShader (program, shader);
}

void glDetachShader (GLuint program, GLuint shader)
{
	pglDetachShader (program, shader);
}

void glLinkProgram (GLuint program)
{
	pglLinkProgram (program);
}

void glUseProgram (GLuint program)
{
	pglUseProgram (program);
}

void glBindAttribLocation (GLuint program, GLuint index, const GLchar *name)
{
	pglBindAttribLocation (program, index, name);
}

GLint glGetAttribLocation (GLuint program, const GLchar *name)
{
	return pglGetAttribLocation (program, name);
}

void glGetActiveAttrib (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name)
{
	pglGetActiveAttrib (program, index, bufSize, length, size, type, name);
}

void glGetActiveUniform (GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name)
{
	pglGetActiveUniform (program, index, bufSize, length, size, type, name);
}

void glGetAttachedShaders (GLuint program, GLsizei maxCount, GLsizei *count, GLuint *obj)
{
	pglGetAttachedShaders (program, maxCount, count, obj);
}

GLint glGetUniformLocation (GLuint program, const GLchar *name)
{
	return pglGetUniformLocation (program, name);
}

void glUniform1f (GLint location, GLfloat v0)
{
	pglUniform1f (location, v0);
}

void glUniform2f (GLint location, GLfloat v0, GLfloat v1)
{
	pglUniform2f (location, v0, v1);
}

void glUniform3f (GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
	pglUniform3f (location, v0, v1, v2);
}

void glUniform4f (GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
	pglUniform4f (location, v0, v1, v2, v3);
}

void glUniform1i (GLint location, GLint v0)
{
	pglUniform1i (location, v0);
}

void glUniform2i (GLint location, GLint v0, GLint v1)
{
	pglUniform2i (location, v0, v1);
}

void glUniform3i (GLint location, GLint v0, GLint v1, GLint v2)
{
	pglUniform3i (location, v0, v1, v2);
}

void glUniform4i (GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
	pglUniform4i (location, v0, v1, v2, v3);
}

void glUniformMatrix2fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
	pglUniformMatrix2fv (location, count, transpose, value);
}

void glUniformMatrix3fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
	pglUniformMatrix3fv (location, count, transpose, value);
}

void glUniformMatrix4fv (GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
	pglUniformMatrix4fv (location, count, transpose, value);
}
*/

/*
bool LoadShaderFunctions()
{
	// Load each of the needed function calls
	pglCreateProgram = (PFNGLCREATEPROGRAMOBJECTARBPROC)SDL_GL_GetProcAddress("glCreateProgram");

	if (!pglCreateProgram)
	{
		Log("glCreateProgram not found. Now exiting.\n");
		return false;
	}

	pglCreateShader = (PFNGLCREATESHADEROBJECTARBPROC)SDL_GL_GetProcAddress("glCreateShader");

	if (!pglCreateShader)
	{
		Log("glCreateShader not found. Now exiting.\n");
		return false;
	}

	pglShaderSource = (PFNGLSHADERSOURCEARBPROC)SDL_GL_GetProcAddress("glShaderSource");

	if (!pglShaderSource)
	{
		Log("glShaderSource not found. Now exiting.\n");
		return false;
	}

	pglCompileShader = (PFNGLCOMPILESHADERARBPROC)SDL_GL_GetProcAddress("glCompileShader");

	if (!pglCompileShader)
	{
		Log("glCompileShader not found. Now exiting.\n");
		return false;
	}
	
	pglGetShaderInfoLog = (PFNGLGETSHADERINFOLOGPROC)SDL_GL_GetProcAddress("glGetShaderInfoLog");

	if (!pglGetShaderInfoLog)
	{
		Log("glGetShaderInfoLog not found. Now exiting.\n");
		return false;
	}

	pglGetShaderSource = (PFNGLGETSHADERSOURCEARBPROC)SDL_GL_GetProcAddress("glGetShaderSource");

	if (!pglGetShaderSource)
	{
		Log("glGetShaderSource not found. Now exiting.\n");
		return false;
	}

	pglGetShaderiv = (PFNGLGETSHADERIVPROC)SDL_GL_GetProcAddress("glGetShaderiv");

	if (!pglGetShaderiv)
	{
		Log("glGetShaderiv not found. Now exiting.\n");
		return false;
	}

	pglDeleteShader = (PFNGLDELETESHADERPROC)SDL_GL_GetProcAddress("glDeleteShader");

	if (!pglDeleteShader)
	{
		Log("glDeleteShader not found. Now exiting.\n");
		return false;
	}
	
	pglDeleteProgram = (PFNGLDELETEPROGRAMPROC)SDL_GL_GetProcAddress("glDeleteProgram");

	if (!pglDeleteProgram)
	{
		Log("glDeleteProgram not found. Now exiting.\n");
		return false;
	}

	pglGetProgramInfoLog = (PFNGLGETPROGRAMINFOLOGPROC)SDL_GL_GetProcAddress("glGetProgramInfoLog");

	if (!pglGetProgramInfoLog)
	{
		Log("glGetProgramInfoLog not found. Now exiting.\n");
		return false;
	}

	pglValidateProgram = (PFNGLVALIDATEPROGRAMARBPROC)SDL_GL_GetProcAddress("glValidateProgram");

	if (!pglValidateProgram)
	{
		Log("glValidateProgram not found. Now exiting.\n");
		return false;
	}

	pglGetProgramiv = (PFNGLGETPROGRAMIVPROC)SDL_GL_GetProcAddress("glGetProgramiv");

	if (!pglGetProgramiv)
	{
		Log("glGetProgramiv not found. Now exiting.\n");
		return false;
	}

	pglAttachShader = (PFNGLATTACHSHADERPROC)SDL_GL_GetProcAddress("glAttachShader");

	if (!pglAttachShader)
	{
		Log("glAttachShader not found. Now exiting.\n");
		return false;
	}

	pglDetachShader = (PFNGLDETACHSHADERPROC)SDL_GL_GetProcAddress("glDetachShader");

	if (!pglDetachShader)
	{
		Log("glDetachShader not found. Now exiting.\n");
		return false;
	}

	pglLinkProgram = (PFNGLLINKPROGRAMPROC)SDL_GL_GetProcAddress("glLinkProgram");

	if (!pglLinkProgram)
	{
		Log("glLinkProgram not found. Now exiting.\n");
		return false;
	}

	pglUseProgram = (PFNGLUSEPROGRAMPROC)SDL_GL_GetProcAddress("glUseProgram");

	if (!pglUseProgram)
	{
		Log("glUseProgram not found. Now exiting.\n");
		return false;
	}

	pglBindAttribLocation = (PFNGLBINDATTRIBLOCATIONPROC)SDL_GL_GetProcAddress("glBindAttribLocation");

	if (!pglBindAttribLocation)
	{
		Log("glBindAttribLocation not found. Now exiting.\n");
		return false;
	}

	pglGetAttribLocation = (PFNGLGETATTRIBLOCATIONPROC)SDL_GL_GetProcAddress("glGetAttribLocation");

	if (!pglGetAttribLocation)
	{
		Log("glGetAttribLocation not found. Now exiting.\n");
		return false;
	}

	pglGetActiveAttrib = (PFNGLGETACTIVEATTRIBPROC)SDL_GL_GetProcAddress("glGetActiveAttrib");

	if (!pglGetActiveAttrib)
	{
		Log("glGetActiveAttrib not found. Now exiting.\n");
		return false;
	}

	pglGetActiveUniform = (PFNGLGETACTIVEUNIFORMPROC)SDL_GL_GetProcAddress("glGetActiveUniform");

	if (!pglGetActiveUniform)
	{
		Log("glGetActiveUniform not found. Now exiting.\n");
		return false;
	}

	pglGetAttachedShaders = (PFNGLGETATTACHEDSHADERSPROC)SDL_GL_GetProcAddress("glGetAttachedShaders");

	if (!pglGetAttachedShaders)
	{
		Log("glGetAttachedShaders not found. Now exiting.\n");
		return false;
	}

	pglGetUniformLocation = (PFNGLGETUNIFORMLOCATIONPROC)SDL_GL_GetProcAddress("glGetUniformLocation");

	if (!pglGetUniformLocation)
	{
		Log("glGetUniformLocation not found. Now exiting.\n");
		return false;
	}

	pglUniform1f = (PFNGLUNIFORM1FPROC)SDL_GL_GetProcAddress("glUniform1f");

	if (!pglUniform1f)
	{
		Log("glUniform1f not found. Now exiting.\n");
		return false;
	}

	pglUniform2f = (PFNGLUNIFORM2FPROC)SDL_GL_GetProcAddress("glUniform2f");

	if (!pglUniform2f)
	{
		Log("glUniform2f not found. Now exiting.\n");
		return false;
	}

	pglUniform3f = (PFNGLUNIFORM3FPROC)SDL_GL_GetProcAddress("glUniform3f");

	if (!pglUniform3f)
	{
		Log("glUniform3f not found. Now exiting.\n");
		return false;
	}

	pglUniform4f = (PFNGLUNIFORM4FPROC)SDL_GL_GetProcAddress("glUniform4f");

	if (!pglUniform4f)
	{
		Log("glUniform4f not found. Now exiting.\n");
		return false;
	}

	pglUniform1i = (PFNGLUNIFORM1IPROC)SDL_GL_GetProcAddress("glUniform1i");

	if (!pglUniform1i)
	{
		Log("glUniform1i not found. Now exiting.\n");
		return false;
	}

	pglUniform2i = (PFNGLUNIFORM2IPROC)SDL_GL_GetProcAddress("glUniform2i");

	if (!pglUniform2i)
	{
		Log("glUniform2i not found. Now exiting.\n");
		return false;
	}

	pglUniform3i = (PFNGLUNIFORM3IPROC)SDL_GL_GetProcAddress("glUniform3i");

	if (!pglUniform3i)
	{
		Log("glUniform3i not found. Now exiting.\n");
		return false;
	}

	pglUniform4i = (PFNGLUNIFORM4IPROC)SDL_GL_GetProcAddress("glUniform4i");

	if (!pglUniform4i)
	{
		Log("glUniform4i not found. Now exiting.\n");
		return false;
	}

	pglUniformMatrix2fv = (PFNGLUNIFORMMATRIX2FVPROC)SDL_GL_GetProcAddress("glUniformMatrix2fv");

	if (!pglUniformMatrix2fv)
	{
		Log("glUniformMatrix2fv not found. Now exiting.\n");
		return false;
	}

	pglUniformMatrix3fv = (PFNGLUNIFORMMATRIX3FVPROC)SDL_GL_GetProcAddress("glUniformMatrix3fv");

	if (!pglUniformMatrix3fv)
	{
		Log("glUniformMatrix3fv not found. Now exiting.\n");
		return false;
	}
	
	pglUniformMatrix4fv = (PFNGLUNIFORMMATRIX4FVPROC)SDL_GL_GetProcAddress("glUniformMatrix4fv");

	if (!pglUniformMatrix4fv)
	{
		Log("glUniformMatrix4fv not found. Now exiting.\n");
		return false;
	}

	return true;
}
*/
/*
int LoadVBOFunctions()
{
	pglGenBuffersARB = (PFNGLGENBUFFERSARBPROC)SDL_GL_GetProcAddress("glGenBuffersARB");

	if (!pglGenBuffersARB)
	{
		Log("glGenBuffersARB not found. Now exiting.\n");
		return FALSE;
	}

	pglBindBufferARB = (PFNGLBINDBUFFERARBPROC)SDL_GL_GetProcAddress("glBindBufferARB");

	if (!pglBindBufferARB)
	{
		Log("glBindBufferARB not found. Now exiting.\n");
		return FALSE;
	}

	pglBufferDataARB = (PFNGLBUFFERDATAARBPROC)SDL_GL_GetProcAddress("glBufferDataARB");

	if (!pglBufferDataARB)
	{
		Log("glBufferDataARB not found. Now exiting.\n");
		return FALSE;
	}

	pglBufferSubDataARB = (PFNGLBUFFERSUBDATAARBPROC)SDL_GL_GetProcAddress("glBufferSubDataARB");

	if (!pglBufferSubDataARB)
	{
		Log("glBufferSubDataARB not found. Now exiting.\n");
		return FALSE;
	}

	pglDeleteBuffersARB = (PFNGLDELETEBUFFERSARBPROC)SDL_GL_GetProcAddress("glDeleteBuffersARB");

	if (!pglDeleteBuffersARB)
	{
		Log("glDeleteBuffersARB not found. Now exiting.\n");
		return FALSE;
	}

	return TRUE;
}
*/

// Check for extensions
int ExtensionCheck()
{
    const char *ext = (char*)glGetString(GL_EXTENSIONS);

    Log("Checking Extensions:");

    // Check for texture compression (required)

    if (strstr(ext, "ARB_texture_compression") == NULL)
    {
		Log("ARB_texture_compression not found. Now exiting.\n");
		return FALSE;
    }
    else
	{
        pglCompressedTexImage2DARB = (PFNGLCOMPRESSEDTEXIMAGE2DARBPROC)SDL_GL_GetProcAddress("glCompressedTexImage2DARB");

        if (!pglCompressedTexImage2DARB)
        {
			Log("glCompressedTexImage2DARB not found. Now exiting.\n");
			return FALSE;
        }
    }

	Log("ARB_texture_compression found!");
	
	// Now check for VBO support!

	/*
	if( strstr( ext, "GL_ARB_vertex_buffer_object" ) == NULL )
	{
		Log("GL_ARB_vertex_buffer_object not found. Now exiting.\n");
		return FALSE;
	}
	
	if (LoadVBOFunctions() == FALSE)
		return FALSE;
	
	Log("GL_ARB_vertex_buffer_object extensions found!");
	*/
	
	/*
	// Time to check for the ol' shader support!

	if( strstr( ext, "GL_ARB_shader_objects" ) == NULL )
	{
		Log("GL_ARB_shader_objects not found. Now exiting.\n");
		return false;
	}

	if( strstr( ext, "GL_ARB_vertex_shader" ) == NULL )
	{
		Log("GL_ARB_vertex_shader not found. Now exiting.\n");
		return false;
	}

	if( strstr( ext, "GL_ARB_fragment_shader" ) == NULL )
	{
		Log("GL_ARB_fragment_shader not found. Now exiting.\n");
		return false;
	}

	if( strstr( ext, "GL_ARB_shading_language_100" ) == NULL )
	{
		Log("GL_ARB_shading_language_100 not found. Now exiting.\n");
		return false;
	}

	if (LoadShaderFunctions() == false)
		return false;
	
	

	Log("Shader extensions are all good!");
	*/
    // Now check for multitexturing!

	/*
    UseMultitexture = TRUE;

    if (strstr(ext ,"ARB_multitexture") == NULL)
    {
        Log("ARB_multitexture not found. Multitexturing disabled.");
        UseMultitexture = FALSE;
    }
    else
    {
        pglMultiTexCoord2fARB = (PFNGLMULTITEXCOORD2FARBPROC)SDL_GL_GetProcAddress("glMultiTexCoord2fARB");

        if (!pglMultiTexCoord2fARB)
        {
			Log("glMultiTexCoord2fARB not found. Multitexturing disabled.");
            UseMultitexture = FALSE;
        }
    }

    if (UseMultitexture == TRUE)
        Log("Multitexturing extensions found!");
	*/
	
    return TRUE;
}

#endif
