#ifndef _INPUT_C_
#define _INPUT_C_

#include "SDL.h"

#include "common.h"
#include "input.h"

InputType InputState;

void HandleInput()
{
	static SDL_Event e;

	while (SDL_PollEvent(&e))
		switch (e.type) {
			case SDL_QUIT:

				InputState.NeedToShutDown = TRUE;
				break;

			case SDL_KEYDOWN:
				switch (e.key.keysym.sym)
				{
					case SDLK_UP:
						//InputState.
						break;
					case SDLK_DOWN:
						InputState.MoveDown = TRUE;
						break;
					case SDLK_RIGHT:
						InputState.MoveRight = TRUE;
						break;
					case SDLK_LEFT:
						InputState.MoveLeft = TRUE;
						break;
					case SDLK_z:
						InputState.TryRotate = TRUE;
						break;
					case SDLK_RETURN:
						if (e.key.keysym.mod & KMOD_ALT)
						{
							//setvideo(fullscreen = 1-fullscreen);
						}
						break;
					case SDLK_SPACE:
												
						break;
					case SDLK_ESCAPE:
						//InputState.NeedToShutDown = TRUE;
						break;
					default:
						break;
				}
				break;

			case SDL_KEYUP:
				switch (e.key.keysym.sym)
				{
					case SDLK_DOWN:
						InputState.MoveDown = FALSE;
						break;
					case SDLK_RIGHT:
						InputState.MoveRight = FALSE;
						break;
					case SDLK_LEFT:
						InputState.MoveLeft = FALSE;
						break;
					case SDLK_z:
						InputState.TryRotate = FALSE;
						break;
					case SDLK_RETURN:
						if (e.key.keysym.mod & KMOD_ALT)
						{
							//setvideo(fullscreen = 1-fullscreen);
						}
						break;
					case SDLK_SPACE:
												
						break;
					case SDLK_ESCAPE:
						InputState.ESCPressed = TRUE;
						break;
					default:
						break;
				}

			case SDL_MOUSEMOTION:

				//InputState.MousePosX = e.motion.x;
				//InputState.MousePosY = e.motion.y;

				break;

	}

	return;
}

#endif