// TowerDefense.cpp : Defines the entry point for the console application.
//

// Windows junk
#include "targetver.h"
#include <windows.h>
#define WIN32_LEAN_AND_MEAN
#define WIN32_EXTRA_LEAN

// System includes
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "SDL.h"
#include "SDL_opengl.h"

// Local includes
#include "common.h"
#include "init.h"
#include "texture.h"
#include "cGuy.h"
#include "cBlock.h"
#include "Pieces.h"
#include "game.h"
#include "sound.h"

int SDL_main(int argc, char **argv)
{
	// randamize omg lol
	srand ((unsigned int) time(NULL));

	InitLog();

	Log("Welcome to fydo's LD17 entry!");

	// Load up the config file and set settings

	// Execute Initialization routines for various systems
	if (Configuration(argc, argv) == FALSE)
		return 1;

	if (InitPhysFS(argv[0]) == FALSE)
		return 1;

	if (InitSDLThings() == FALSE)
		return 1;

	//if (InitSound() == FALSE)
	//	return 1;
	
	InitSound();

	if (SetupOpenGL() == FALSE)
		return 1;

	InitInput();

	MainLoop();

	Shutdown(0); // from common

	// Since there is a quit() in Shutdown, we should never reach this place.
	
	return 0;
}
